from typing import Final


# ====== CA: Common Attribute ======

class CA:
    Add: Final[str] = "add"
    All: Final[str] = "all"
    Api: Final[str] = "api"
    Ascending: Final[str] = "asc"  # in SQL
    Auth: Final[str] = "aut"

    Book: Final[str] = "b"
    BookChapterVersionComboId: Final[str] = "bcvcid"
    BookHeadVersionId: Final[str] = "bhvid"
    BookId: Final[str] = "bid"
    BookList: Final[str] = "bl"
    BookListId: Final[str] = "blid"
    BookVersion: Final[str] = "bv"
    BookVersionId: Final[str] = "bvid"
    BookVersionNo: Final[str] = "bvno"
    Bookkeeping: Final[str] = "bk"
    BookkeepingId: Final[str] = "bkid"
    Button: Final[str] = "btn"

    Cancel: Final[str] = "ccl"
    Chapter: Final[str] = "c"
    ChapterBoneId: Final[str] = "cbnid"
    ChapterBoneWordId: Final[str] = "cbnwid"
    ChapterHeadVersionId: Final[str] = "chvid"
    ChapterId: Final[str] = "cid"
    ChapterVersion: Final[str] = "cv"
    ChapterVersionId: Final[str] = "cvid"
    ChapterVersionNo: Final[str] = "cvno"
    ChapterWordId: Final[str] = "cwid"
    Character: Final[str] = "chr"
    Check: Final[str] = "chk"
    Clear: Final[str] = "cls"
    Click: Final[str] = "clk"
    Close: Final[str] = "cle"
    Code: Final[str] = "cd"
    Collect: Final[str] = "clt"
    Collected: Final[str] = "cltd"
    Color: Final[str] = "col"
    Confirm: Final[str] = "cfm"
    Context: Final[str] = "ctt"
    Count: Final[str] = "cnt"
    Create: Final[str] = "ct"
    CreateTime: Final[str] = "crt"

    Data: Final[str] = "dt"
    Database: Final[str] = "db"
    Delete: Final[str] = "del"  # in SQL
    Descending: Final[str] = "desc"  # in SQL
    Description: Final[str] = "des"
    DescriptionFormatted: Final[str] = "desf"
    DescriptionId: Final[str] = "desid"
    DescriptionPlain: Final[str] = "desp"
    Details: Final[str] = "dts"
    Drawer: Final[str] = "dwr"

    Empty: Final[str] = "ety"
    End: Final[str] = "ed"

    Field: Final[str] = "fid"
    Find: Final[str] = "fnd"
    Finished: Final[str] = "fied"
    FinishedWord: Final[str] = "fw"
    First: Final[str] = "fst"
    Focus: Final[str] = "fcs"
    Focused: Final[str] = "fcsd"
    Focusing: Final[str] = "fcsg"
    Footer: Final[str] = "ftr"
    Formatted: Final[str] = "fmt"
    FrontEnd: Final[str] = "fe"

    Grid: Final[str] = "gd"
    Group: Final[str] = "gp"

    Head: Final[str] = "hd"
    HeadVersion: Final[str] = "hv"
    Header: Final[str] = "hdr"
    Height: Final[str] = "ht"
    Hide: Final[str] = "hde"
    History: Final[str] = "hy"
    Home: Final[str] = "he"
    HttpStatus: Final[str] = "hts"

    Id: Final[str] = "id"
    Importance: Final[str] = "ipt"
    Info: Final[str] = "inf"
    InfoRow: Final[str] = "inr"
    Init: Final[str] = "it"
    Input: Final[str] = "inp"
    Item: Final[str] = "im"
    ItemPerPage: Final[str] = "impp"

    Learn: Final[str] = "l"
    LearnBookVersionId: Final[str] = "lbvid"
    # LearnChapterVersionId: Final[str] = 'lcvid'
    Learner: Final[str] = "lr"
    LearnerId: Final[str] = "lrid"
    LearnerSaId: Final[str] = "lrsaid"
    Limit: Final[str] = "lmt"
    List: Final[str] = "lt"
    ListWordId: Final[str] = "ltwid"
    Log: Final[str] = "log"
    Login: Final[str] = "lgn"
    Logo: Final[str] = "loo"

    Main: Final[str] = "main"
    Major: Final[str] = "mar"
    Mentor: Final[str] = "mr"
    MentorId: Final[str] = "mrid"
    Message: Final[str] = "msg"

    Name: Final[str] = "na"
    Navigator: Final[str] = "nav"
    New: Final[str] = "new"
    Next: Final[str] = "nxt"
    NextBookVersion: Final[str] = "nbkv"
    Not: Final[str] = "not"
    Note: Final[str] = "nt"

    Ok: Final[str] = "ok"
    One: Final[str] = 'one'
    Open: Final[str] = 'opn'
    OrderRank: Final[str] = "odr"

    Page: Final[str] = "pg"
    Parameter: Final[str] = "pm"
    Password: Final[str] = "pw"
    Plain: Final[str] = "pn"
    Preference: Final[str] = "pfe"
    Previous: Final[str] = 'prs'
    Private: Final[str] = "pvt"
    Privilege: Final[str] = "pvl"
    Proficiency: Final[str] = 'pfy'
    Public: Final[str] = "pb"

    Query: Final[str] = "qy"
    Quest: Final[str] = "qt"

    Read: Final[str] = "rd"
    Remove: Final[str] = "rm"
    Request: Final[str] = "req"
    Response: Final[str] = "rsp"
    Result: Final[str] = "ret"
    Right: Final[str] = "r"
    Role: Final[str] = "rol"
    Rotation: Final[str] = "rot"

    Save: Final[str] = "sav"
    Scale: Final[str] = "scl"
    Search: Final[str] = "sch"
    SearchType: Final[str] = "sht"
    Section: Final[str] = "set"
    Sentence: Final[str] = "sn"
    SentenceAudio: Final[str] = "sa"
    SentenceAudioId: Final[str] = "said"
    SentenceId: Final[str] = "snid"
    Series: Final[str] = "ses"
    Show: Final[str] = "shw"
    Signup: Final[str] = "sgu"
    Similarity: Final[str] = "smy"
    Size: Final[str] = "siz"
    SortBy: Final[str] = "stby"
    SortDirection: Final[str] = "stdr"
    Star: Final[str] = "str"
    Stars: Final[str] = "strs"
    Start: Final[str] = "str"
    State: Final[str] = "ste"
    Statistics: Final[str] = "stc"
    Status: Final[str] = "sts"
    Summary: Final[str] = "sy"

    Tag: Final[str] = "tag"
    Text: Final[str] = "txt"
    Time: Final[str] = "tm"
    TimeNow: Final[str] = "tnw"
    TimeZone: Final[str] = "tmz"
    Title: Final[str] = "tt"
    TitleId: Final[str] = "ttid"
    TotalCount: Final[str] = "tcnt"
    TotalCountWithoutFilter: Final[str] = "tcntwtf"
    TotalSec: Final[str] = "tls"
    Transform: Final[str] = "tsf"
    Type: Final[str] = "tp"

    Unknown: Final[str] = "ukn"
    Update: Final[str] = "ud"
    UpdateTime: Final[str] = "udt"
    Used: Final[str] = "used"
    User: Final[str] = "usr"
    UserId: Final[str] = "uid"
    Util: Final[str] = "util"

    Version: Final[str] = "vn"
    VersionCreate: Final[str] = "vct"
    VersionId: Final[str] = "vid"
    VersionNo: Final[str] = "vno"
    Visited: Final[str] = "vst"
    Visiting: Final[str] = "vstng"
    Voice: Final[str] = "voc"
    VolWorld: Final[str] = "vw"

    Warning: Final[str] = "wag"
    # WfMedian: Final[str] = "wfm"
    Width: Final[str] = "wh"
    Word: Final[str] = "w"
    WordBookLibrary: Final[str] = "wbl"
    WordFrequency: Final[str] = "wf"
    WordId: Final[str] = "wid"
    WordIdList: Final[str] = "widlst"
    WordLearn: Final[str] = 'wl'

    ___Error___: Final[str] = "err"
